﻿Public Class Form1

    ' timer를 사용하는 경우 사용할 카운트값. 기본값 10
    Private m_iEndCount As Integer

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
        ' 현재 Form을 MainForm으로 설정합니다.
        SmartForm1.MainForm = Me

        ' SmartMessageBox의 Size 설정
        SmartX.SmartMessageBox.Size(500, 250)
        ' SmartMessageBox가 다른 컴포넌트에 가려지지 않도록 최상단에 보여지도록 설정
        SmartX.SmartMessageBox.TopMost = True
        ' SmartMessageBox를 NoneBlocking 방식으로 사용하기 위한 설정.
        SmartX.SmartMessageBox.OwnerHandle = Me.Handle
        ' SmartMessageBox를 NoneBlocking 방식으로 Show된 후 Close될 때 발생하는 이벤트를 추가
        AddHandler SmartX.SmartMessageBox.OnNoneBlockingDialogClosing, AddressOf SmartMessageBox_OnNoneBlockingDialogClosing

        ' 멤버 변수 초기화
        m_iEndCount = 10
    End Sub

    ' SmartMessageBox 종료 시간 설정
    Private Sub btnTimeSet_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnTimeSet.Click
        SmartTimer1.CounterMode = SmartX.SmartTimer.CounterModes.Down_Counter

        ' SmartTimer의 TimeCount 설정
        SmartTimer1.TimeCount = (CLng(udEndTimeSet.Value) * CLng(1000))

        ' 각 Timer의 Interval 설정. (1000 = 1Sec)
        SmartTimer1.Interval = 1000
        Timer1.Interval = 1000
    End Sub

    ' SmartMessageBox를 NoneBlocking 방식으로 Show하는 Click 이벤트
    Private Sub ShowSmartMessageBox_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnTimer.Click, btnSmartTimer.Click
        ' SmartMessageBox의 Caption, Message, Button에 출력할 초기 텍스트를 저장
        Dim strSetTime As String = udEndTimeSet.Value.ToString()

        ' Timer Count 설정
        m_iEndCount = Convert.ToInt32(udEndTimeSet.Value)

        ' SmartMessageBox를 NoneBlocking 방식으로 Show
        SmartX.SmartMessageBox.Show_NoneBlocking(strSetTime & "초 후 자동으로 닫히는 메시지박스 입니다.", strSetTime & "초 후 닫힙니다.", strSetTime, strSetTime, strSetTime, SmartX.CMsgBoxIcon.Hand)

        If sender Is btnSmartTimer Then
            ' 선택한 버튼이 "SmartTimer사용"인 경우
            SmartTimer1.Start()
        Else
            ' 선택한 버튼이 "Timer사용"인 경우
            Timer1.Enabled = True
        End If
    End Sub

    ' SmartMessageBox가 Close될 때 발생하는 이벤트. (dResult : SmartMessageBox에서 선택한 버튼)
    Private Sub SmartMessageBox_OnNoneBlockingDialogClosing(ByVal dResult As SmartX.CDialogResult)
        ' SmartTimer, Timer를 정지합니다.
        If SmartTimer1.IsStart = True Then
            SmartTimer1.Stop()
        Else
            Timer1.Enabled = False
            ' 카운트를 초기화합니다
            m_iEndCount = Convert.ToInt32(udEndTimeSet.Value)
        End If
    End Sub

    ' SmartTimer를 이용하여 SmartMessageBox의 Text를 변경하는 Tick 이벤트
    Private Sub smartTimer1_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles SmartTimer1.Tick
        ' SmartTimer의 현재 시간의 초(Sec)값을 가져옵니다.
        Dim lNowTime As Long = SmartTimer1.GetNowTimeFormat(SmartX.SmartTimer.TimeConvertFormatTypes.Minute_Second).dwSec

        ' SmartTimer의 현재 시간의 밀리초(ms)값을 가져옵니다.
        Dim lNowTimeMilli As Long = SmartTimer1.GetNowTimeFormat(SmartX.SmartTimer.TimeConvertFormatTypes.Minute_Second).dwMillisecond

        ' 현재 시간이 만약 8sec 900ms 인 경우, 즉 시간을 내림하여 체크하는 경우를 방지하기 위해
        ' 현재 ms가 500을 초과하는 경우 현재 Sec를 1초 더합니다.
        If lNowTimeMilli > 500 Then
            lNowTime += 1
        End If

        ' 카운트가 0이되면 메시지박스를 Closing
        If lNowTime <= 0 Then
            ' SmartMessageBox를 Closing하는 메서드
            SmartX.SmartMessageBox.Close_NoneBlocking()
        Else
            Dim strTime As String = lNowTime.ToString("00")
            ' 버튼의 텍스트를 변경
            SmartX.SmartMessageBox.SetButsText_NoneBlocking(strTime, strTime, strTime)

            ' 캡션의 텍스트를 변경
            SmartX.SmartMessageBox.SetCaption_NoneBlocking(strTime & "초 후 닫힙니다.")

            ' 메시지의 텍스트를 변경
            SmartX.SmartMessageBox.SetMessage_NoneBlocking(strTime & "초 후 자동으로 닫히는 메시지박스 입니다.")
        End If
    End Sub

    ' SmartTimer의 시간이 EndTime이 될 때 발생하는 이벤트.
    Private Sub smartTimer1_OnFinishTick(ByVal sender As Object, ByVal e As EventArgs) Handles SmartTimer1.OnFinishTick
        ' SmartMessageBox를 Closing하는 메서드
        SmartX.SmartMessageBox.Close_NoneBlocking()
    End Sub

    ' Timer를 이용하여 SmartMessageBox의 Text를 변경하는 Tick 이벤트
    Private Sub timer1_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles Timer1.Tick
        ' 변수를 이용하는 방법.
        ' 이 방법은 백그라운드 작업에 따라 시간이 지연될 수 있습니다.
        If System.Threading.Interlocked.Decrement(m_iEndCount) <= 0 Then
            ' SmartMessageBox를 Closing하는 메서드
            SmartX.SmartMessageBox.Close_NoneBlocking()
        Else
            ' 버튼의 텍스트를 변경
            SmartX.SmartMessageBox.SetButsText_NoneBlocking(m_iEndCount.ToString(), m_iEndCount.ToString(), m_iEndCount.ToString())

            ' 캡션의 텍스트를 변경
            SmartX.SmartMessageBox.SetCaption_NoneBlocking(m_iEndCount.ToString() & " 초후 닫힙니다.")

            ' 메시지의 텍스트를 변경
            SmartX.SmartMessageBox.SetMessage_NoneBlocking(m_iEndCount.ToString() & " 초 후 자동으로 닫히는 메시지박스 입니다.")
        End If
    End Sub

    ' CPU 사용량을 증가시키기 위한 Timer를 Start하는 메서드
    Private Sub btnDrawStart_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnDrawStart.Click
        ' SmartTimer1의 Interval 값을 줄이면 더 정확한 시간을 체크할 수 있습니다.
        ' 기본 설정값 : smartTimer1.Interval = 1000;

        ' 부하 시작
        SmartTimer2.Start()
    End Sub

    ' SmartDraw를 For문을 사용해 여러 도형을 랜덤으로 그리게 하여 CPU 사용량을 증가시킵니다.
    Private Sub smartTimer2_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles SmartTimer2.Tick
        SmartTimer2.Stop()
        ' 랜덤변수 생성
        Dim rdVal As Random = New Random()
        Dim rdRepeat As Random = New Random()
        Dim iRand As Integer = rdRepeat.Next(0, 5)

        ' 도형의 크기설정을 위한 변수
        Dim iWidth, iHeight, iTop, iLeft As Integer
        smartDraw1.SetBrushStyle(Color.Black)

        ' Draw할 도형을 랜덤으로 선택
        ' 각 도형은 For문을 사용하여 500번씩 반복하여 Draw합니다.
        Select Case iRand
            Case 0
                For i As Integer = 0 To 500 - 1
                    smartDraw1.SetPenStyle(Color.FromArgb(rdVal.Next(&HFFFFFF)), 1)
                    smartDraw1.Line(rdVal.Next(10, 720), rdVal.Next(10, 360), rdVal.Next(10, 720), rdVal.Next(10, 360))
                    Application.DoEvents()
                Next
            Case 1
                For i As Integer = 0 To 500 - 1
                    iTop = rdVal.Next(10, 350)
                    iLeft = rdVal.Next(10, 710)
                    iWidth = rdVal.Next(0, (710 - iLeft))
                    iHeight = rdVal.Next(0, (350 - iTop))
                    smartDraw1.SetBrushStyle(Color.FromArgb(rdVal.Next(&HFFFFFF)))
                    smartDraw1.SetPenStyle(Color.FromArgb(rdVal.Next(&HFFFFFF)), 1)
                    smartDraw1.Rectangle(iLeft, iTop, iWidth, iHeight)
                    Application.DoEvents()
                Next
            Case 2
                For i As Integer = 0 To 500 - 1
                    iTop = rdVal.Next(10, 350)
                    iLeft = rdVal.Next(10, 710)
                    iWidth = rdVal.Next(0, (710 - iLeft))
                    iHeight = rdVal.Next(0, (350 - iTop))
                    smartDraw1.SetBrushStyle(Color.FromArgb(rdVal.Next(&HFFFFFF)))
                    smartDraw1.SetPenStyle(Color.FromArgb(rdVal.Next(&HFFFFFF)), 1)
                    smartDraw1.RoundRect(iLeft, iTop, iWidth, iHeight, rdVal.Next(30))
                    Application.DoEvents()
                Next
            Case 3
                For i As Integer = 0 To 500 - 1
                    smartDraw1.SetBrushStyle(Color.FromArgb(rdVal.Next(&HFFFFFF)))
                    smartDraw1.SetPenStyle(Color.FromArgb(rdVal.Next(&HFFFFFF)), 1)
                    smartDraw1.Circle(rdVal.Next(710), rdVal.Next(350), rdVal.Next(100))
                    Application.DoEvents()
                Next
            Case 4
                For i As Integer = 0 To 500 - 1
                    smartDraw1.SetBrushStyle(Color.FromArgb(rdVal.Next(&HFFFFFF)))
                    smartDraw1.SetPenStyle(Color.FromArgb(rdVal.Next(&HFFFFFF)), 1)
                    smartDraw1.Ellipse(rdVal.Next(710), rdVal.Next(350), rdVal.Next(100), rdVal.Next(100))
                    Application.DoEvents()
                Next
            Case 5
                Dim points As Point() = New Point(9) {}
                Dim iSize, iXOffset, iYOffset As Integer

                For i As Integer = 0 To 500 - 1
                    iSize = rdVal.Next(5)
                    iXOffset = rdVal.Next(700)
                    iYOffset = rdVal.Next(350)
                    smartDraw1.SetBrushStyle(Color.FromArgb(rdVal.Next(&HFFFFFF)))
                    smartDraw1.SetPenStyle(Color.FromArgb(rdVal.Next(&HFFFFFF)), 1)
                    points(0).X = (16 * iSize) + iXOffset
                    points(0).Y = (28 * iSize) + iYOffset
                    points(1).X = (19 * iSize) + iXOffset
                    points(1).Y = (17 * iSize) + iYOffset
                    points(2).X = (30 * iSize) + iXOffset
                    points(2).Y = (17 * iSize) + iYOffset
                    points(3).X = (21 * iSize) + iXOffset
                    points(3).Y = (11 * iSize) + iYOffset
                    points(4).X = (25 * iSize) + iXOffset
                    points(4).Y = (1 * iSize) + iYOffset
                    points(5).X = (16 * iSize) + iXOffset
                    points(5).Y = (7 * iSize) + iYOffset
                    points(6).X = (7 * iSize) + iXOffset
                    points(6).Y = (1 * iSize) + iYOffset
                    points(7).X = (11 * iSize) + iXOffset
                    points(7).Y = (11 * iSize) + iYOffset
                    points(8).X = (2 * iSize) + iXOffset
                    points(8).Y = (17 * iSize) + iYOffset
                    points(9).X = (13 * iSize) + iXOffset
                    points(9).Y = (17 * iSize) + iYOffset
                    smartDraw1.Polygon(points)
                    Application.DoEvents()
                Next
        End Select

        SmartTimer2.Start()
    End Sub

    ' "부하중지" 버튼 클릭 시 발생
    Private Sub btnDrawStop_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnDrawStop.Click
        SmartTimer2.Stop()
    End Sub

    ' 프로그램을 종료할 때 Timer들이 Stard
    Private Sub Form1_Closing(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        If SmartTimer1.IsStart = True Then SmartTimer1.Stop()
        If SmartTimer2.IsStart = True Then SmartTimer2.Stop()
        If Timer1.Enabled = True Then Timer1.Enabled = False
    End Sub
End Class
